/* cc -I/usr/X11R6/include -o cursors cursors.c -L/usr/X11R6/lib -lX11 */

#include <X11/Xlib.h>
#include <X11/cursorfont.h>

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

Display *dpy;
int screen;

void
change_cursor(char *s, unsigned int shape)
{
	printf("changing to %s=%u\n", s, shape);
	Cursor c = XCreateFontCursor(dpy, shape);
	XGrabPointer(dpy, RootWindow(dpy, screen), False, 0, GrabModeAsync,
	    GrabModeAsync, None, c, CurrentTime);
	sleep(2);
	XUngrabPointer(dpy, CurrentTime);
}

#define CHANGE_CURSOR(x) change_cursor(#x, x);

int
main(void)
{
	dpy = XOpenDisplay(NULL);
	if (!dpy)
		exit(1);
	screen = DefaultScreen(dpy);

CHANGE_CURSOR(XC_X_cursor);
CHANGE_CURSOR(XC_arrow);
CHANGE_CURSOR(XC_based_arrow_down);
CHANGE_CURSOR(XC_based_arrow_up);
CHANGE_CURSOR(XC_boat);
CHANGE_CURSOR(XC_bogosity);
CHANGE_CURSOR(XC_bottom_left_corner);
CHANGE_CURSOR(XC_bottom_right_corner);
CHANGE_CURSOR(XC_bottom_side);
CHANGE_CURSOR(XC_bottom_tee);
CHANGE_CURSOR(XC_box_spiral);
CHANGE_CURSOR(XC_center_ptr);
CHANGE_CURSOR(XC_circle);
CHANGE_CURSOR(XC_clock);
CHANGE_CURSOR(XC_coffee_mug);
CHANGE_CURSOR(XC_cross);
CHANGE_CURSOR(XC_cross_reverse);
CHANGE_CURSOR(XC_crosshair);
CHANGE_CURSOR(XC_diamond_cross);
CHANGE_CURSOR(XC_dot);
CHANGE_CURSOR(XC_dotbox);
CHANGE_CURSOR(XC_double_arrow);
CHANGE_CURSOR(XC_draft_large);
CHANGE_CURSOR(XC_draft_small);
CHANGE_CURSOR(XC_draped_box);
CHANGE_CURSOR(XC_exchange);
CHANGE_CURSOR(XC_fleur);
CHANGE_CURSOR(XC_gobbler);
CHANGE_CURSOR(XC_gumby);
CHANGE_CURSOR(XC_hand1);
CHANGE_CURSOR(XC_hand2);
CHANGE_CURSOR(XC_heart);
CHANGE_CURSOR(XC_icon);
CHANGE_CURSOR(XC_iron_cross);
CHANGE_CURSOR(XC_left_ptr);
CHANGE_CURSOR(XC_left_side);
CHANGE_CURSOR(XC_left_tee);
CHANGE_CURSOR(XC_leftbutton);
CHANGE_CURSOR(XC_ll_angle);
CHANGE_CURSOR(XC_lr_angle);
CHANGE_CURSOR(XC_man);
CHANGE_CURSOR(XC_middlebutton);
CHANGE_CURSOR(XC_mouse);
CHANGE_CURSOR(XC_pencil);
CHANGE_CURSOR(XC_pirate);
CHANGE_CURSOR(XC_plus);
CHANGE_CURSOR(XC_question_arrow);
CHANGE_CURSOR(XC_right_ptr);
CHANGE_CURSOR(XC_right_side);
CHANGE_CURSOR(XC_right_tee);
CHANGE_CURSOR(XC_rightbutton);
CHANGE_CURSOR(XC_rtl_logo);
CHANGE_CURSOR(XC_sailboat);
CHANGE_CURSOR(XC_sb_down_arrow);
CHANGE_CURSOR(XC_sb_h_double_arrow);
CHANGE_CURSOR(XC_sb_left_arrow);
CHANGE_CURSOR(XC_sb_right_arrow);
CHANGE_CURSOR(XC_sb_up_arrow);
CHANGE_CURSOR(XC_sb_v_double_arrow);
CHANGE_CURSOR(XC_shuttle);
CHANGE_CURSOR(XC_sizing);
CHANGE_CURSOR(XC_spider);
CHANGE_CURSOR(XC_spraycan);
CHANGE_CURSOR(XC_star);
CHANGE_CURSOR(XC_target);
CHANGE_CURSOR(XC_tcross);
CHANGE_CURSOR(XC_top_left_arrow);
CHANGE_CURSOR(XC_top_left_corner);
CHANGE_CURSOR(XC_top_right_corner);
CHANGE_CURSOR(XC_top_side);
CHANGE_CURSOR(XC_top_tee);
CHANGE_CURSOR(XC_trek);
CHANGE_CURSOR(XC_ul_angle);
CHANGE_CURSOR(XC_umbrella);
CHANGE_CURSOR(XC_ur_angle);
CHANGE_CURSOR(XC_watch);
CHANGE_CURSOR(XC_xterm);

	return 0;
}
